// Exemple d'economiseur d'ecran (cafards.exe et cafardshook.dll)
// Pour tester, lancer cafards /s
//
// Sylvain Marechal
// Rev le 4/12/2003
// Reprise de code Win16 datant des mes annees Parisiennes ou ces petites
// betes me persecutaient :-)
// Le portage concerne principalement le hook
// TODO : Revoir cette vieille classe de gestion des sprites qui date ...
#include <windows.h>
#include "cafards.h"
#include "ecrcaf.h"
#include "mousehook.h"


//------------------------------------------------------------------------------
static HINSTANCE s_hInst;
static HWND s_hWndCafards;
//------------------------------------------------------------------------------
static int ScreenSaverMain( HINSTANCE hInstance, HWND hWndMain );


//------------------------------------------------------------------------------
int PASCAL WinMain( HINSTANCE hInstance,
		   HINSTANCE hPrevInstance,
		   LPSTR lpszCmdParam,
		   int nCmdShow )
		   
{
   LPCTSTR pch = lpszCmdParam;
   HWND hParent = 0;
   OSVERSIONINFO osvi;

   osvi.dwOSVersionInfoSize = sizeof(osvi);
   int fOnWin95 = (GetVersionEx(&osvi) &&
       osvi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS);
   
   // Voir scrnSave.cxx de platform sdk pour la gestion des passwords
   // et de maniere + generale ds le msdn pour la gestion des arguments
   for(;;) 
   {
       switch( *pch )
       {
       case TEXT('S'):
       case TEXT('s'):
	   {
	       return ScreenSaverMain( hInstance, NULL );
	   }
	   
       case TEXT('P'):
       case TEXT('p'):
	   {
	       do pch++; while( *pch == TEXT(' ') );  // skip to the good stuff
	       HWND hWndMain = (HWND)pch;
	       MessageBox( hWndMain, "Sorry, no preview", "Message", MB_ICONINFORMATION );
	       return 0;
	   }
	   
       case TEXT('A'):
       case TEXT('a'):
	   {
	       if (!fOnWin95)
		   return -1;
	       do pch++; while( *pch == TEXT(' ') );  // skip to the good stuff
	       HWND hWndMain = (HWND)pch;
	       
	       MessageBox( hWndMain, "Sorry, no password", "Message", MB_ICONINFORMATION );
	       return 0;
	   }
	   
       case TEXT('C'):
       case TEXT('c'):
	   {
	       MessageBox( GetForegroundWindow(), "No config settings", "Message", MB_ICONINFORMATION );
	       return 0;
	   }
	   
       case TEXT('\0'):
	   {
	       MessageBox( NULL, "No config settings", "Message", MB_ICONINFORMATION );
	       return 0;
	   }
	   
       case TEXT(' '):
       case TEXT('-'):
       case TEXT('/'):
	   {
	       pch++;   // skip spaces and common switch prefixes
	       break;
	   }
	   
       default:
	   {
	       return -1;
	   }
       }
   }
}

//------------------------------------------------------------------------------
int ScreenSaverMain( HINSTANCE hInstance, HWND hWndMain )
{
    HWND	hwnd;
    MSG	msg;
    WNDCLASS	wndclass;
    
    // Creation d'une fenetre invisible
    wndclass.style = CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc = WndProc;
    wndclass.cbClsExtra = 0;
    wndclass.cbWndExtra = 0;
    wndclass.hInstance = hInstance;
    wndclass.hIcon = LoadIcon( NULL, IDI_APPLICATION );
    wndclass.hCursor = LoadCursor( NULL, IDC_ARROW );
    wndclass.hbrBackground = (HBRUSH)GetStockObject( WHITE_BRUSH );
    wndclass.lpszMenuName = NULL;
    wndclass.lpszClassName = "CAFARDS";
    RegisterClass( &wndclass );
    
    // Save globale
    s_hInst = hInstance;
    
    hwnd = CreateWindow( "CAFARDS",
	"",
	WS_OVERLAPPEDWINDOW,
	0,
	0,
	0,
	0,
	NULL,
	NULL,
	hInstance,
	NULL );
        
    // bcle message
    while( GetMessage( &msg, NULL, 0, 0 ) )
    {
	TranslateMessage( &msg );
	DispatchMessage( &msg );
    }
    
    return msg.wParam;
}

//------------------------------------------------------------------------------
static DWORD WINAPI ThreadWaitEvent( LPVOID lpvEventThreadStarted )
{
    HANDLE hEventThreadStarted = (HANDLE)lpvEventThreadStarted;
    HANDLE hHookEvent = CreateEvent( NULL, FALSE, 0, HOOKEVENTNAME );

    if( hHookEvent )
    {
	// Thread lance
	SetEvent( hEventThreadStarted );
	
	// On attend les notifications
	DWORD dwWait = WaitForSingleObject( hHookEvent, INFINITE );
	if( dwWait == WAIT_OBJECT_0 )
	{
	    // => On a bouge la souris, donc on doit quitter
	    PostMessage( s_hWndCafards, WM_DESTROY, 0, 0 );
	}
    }
    return 0;
}


//------------------------------------------------------------------------------
int CreateWaitForHookEvent()
{
    HANDLE hThread; DWORD IDThread;
    int nRet = 0;
    
    // Evenenement signale qd le thread est lance
    HANDLE hEventThreadStarted = CreateEvent( NULL, FALSE, 0, NULL );
    
    // Creation thread qui attend les notifications du hook
    hThread = CreateThread( NULL, 0, ThreadWaitEvent, (LPVOID)hEventThreadStarted, 0, &IDThread );
    if( hThread == NULL ) 
    {
	// erreur ?
	CloseHandle( hEventThreadStarted  );
	return 0;
    }
    
    // Attend un peu que le thread soit lance
    DWORD dwWait = WaitForSingleObject( hEventThreadStarted, 1000 );
    if( dwWait == WAIT_OBJECT_0 )
    {
	nRet = 1;
    }
    
    // Restons propres
    CloseHandle( hEventThreadStarted  );
    CloseHandle( hThread );
    return nRet;    
}


//------------------------------------------------------------------------------
long FAR PASCAL WndProc( HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam )
{
    static uTimer;
    static TEcranCafard * caf = NULL;
    static HHOOK s_hHook = NULL;
    
    switch( message )
    {
    case WM_CREATE :	
	// Save le handle de fenetre ds une globale pour 
	// ThreadWaitEvent()
	s_hWndCafards = hwnd;
	
	// On cree un hook de souris afin de detecter que la souris 
	// a bouge
	// Cela est necessaire pour capturer les messages souris qui se
	// produisent ds les autres applications (typiquement, WM_MOUSEMOVE)
	if( CreateWaitForHookEvent() && InstallCafardHook() )
	{
	    // Une fois le hook cree
	    uTimer = SetTimer( hwnd, NULL, 100, NULL );
	    caf = new TEcranCafard( hwnd, s_hInst, 100 );
	}
        return 0;
	
    case WM_TIMER :
        if( caf ) caf->Move();
        return 0L;
	
	
    case WM_DESTROY :
	if( caf ) 
	{
	    TEcranCafard * cafToDelete = caf;
	    caf = NULL;
	    KillTimer( hwnd, uTimer );
	    delete cafToDelete;
	    PostQuitMessage( 0 );
	    UnInstallCafardHook();
	}
	return 0L;
	
    case WM_KEYDOWN:
    case WM_SYSKEYDOWN:
	{
	    ::SendMessage( hwnd, WM_DESTROY, 0, 0 );
	    return 0;
	}
	
    }
    
    return DefWindowProc( hwnd, message, wParam, lParam );
    
}

