/***********************************************************************/
#include <windows.h>
#include <stdlib.h>
#include "random.h"
#include "ecrcaf.h"
/***********************************************************************/

TEcranCafard::TEcranCafard( HWND hw, HINSTANCE hInst, int nbCafards)
{
    hwnd = hw;
    
    // nb Cafards : Cration du tableau
    MaxCafards = nbCafards;
    aCafard = new TScreenSprite[MaxCafards] ;
    
    // Rcuprer la taille de l'cran
    xEcran = GetSystemMetrics( SM_CXSCREEN );
    yEcran = GetSystemMetrics( SM_CYSCREEN );
    
    // Sauver l'cran
    HDC hdc = ::GetWindowDC( ::GetParent( hwnd ) );
    HDC hdcMemory = ::CreateCompatibleDC(hdc);
    TScreenSprite::SaveScreen( hdc, hdcMemory, xEcran, yEcran );
    ::DeleteDC(hdcMemory);
    ::ReleaseDC(hwnd, hdc);
    
    // initialiser les cafards
    nCafards = 0;
    for( int i = 0; i < MaxCafards; i ++ )
    {
        aCafard[i].Create( hInst, "CAFARD", 8, 2 );
    }
}

/*------------------------------------------------------------------------*/
TEcranCafard::~TEcranCafard()
{
    // Restaurer l'cran
    HDC hdc = ::GetWindowDC( ::GetParent( hwnd ) );
    HDC hdcMemory = ::CreateCompatibleDC(hdc);
    TScreenSprite::RestScreen( hdc, hdcMemory, xEcran, yEcran );
    ::DeleteDC(hdcMemory);
    ::ReleaseDC(hwnd, hdc);
    
    // FIX ME FIX ME !!! delete [] aCafard;
    TScreenSprite::DestroySaveScreen();
}

/*------------------------------------------------------------------------*/
void TEcranCafard::Move()
{
    HDC hdc, hdcMemory; int i;
    
    // HDC du handle de fentre de la mre
    hdc = ::GetWindowDC( ::GetParent( hwnd ) );
    hdcMemory = ::CreateCompatibleDC(hdc);
    
    // On limine ventuellemnt quelques btes
    Tue( hdc, hdcMemory );
    // On en recr quelques autres
    Genere( /*hdc, hdcMemory*/ );
    
    for( i = 0; i < MaxCafards; i ++ )
	MoveCafard( i, hdc, hdcMemory );
    
    // On reste propre
    ::DeleteDC(hdcMemory);
    ::ReleaseDC(hwnd, hdc);
}

/*------------------------------------------------------------------------*/
void TEcranCafard::MoveCafard( int i, HDC hdc,HDC hdcMemory )
{
    if( aCafard[i].Existe() )
    {
        // Changer de position alatoirement
        aCafard[i].Change();
        // Restaurer l'affichage
        aCafard[i].Restaure( hdc, hdcMemory );
        // Rafficher la nouvelle position
        aCafard[i].Save( hdc, hdcMemory );
        aCafard[i].AfficheBlackSprite( hdc, hdcMemory );
    }
}

/*------------------------------------------------------------------------*/
void TEcranCafard::TueTous()
{
    HDC hdc, hdcMemory; int i;
    
    // HDC du handle de fentre de la mre
    hdc = ::GetWindowDC( ::GetParent( hwnd ) );
    hdcMemory = ::CreateCompatibleDC(hdc);
    
    // on parcours dans un sens 1 fois sur 2 ( pb de restauration cran )
    for( i = 0; i < MaxCafards; i ++ )
	TueCafard( i, hdc, hdcMemory );
    
    // On reste propre
    ::DeleteDC(hdcMemory);
    ::ReleaseDC(hwnd, hdc);
}

/*------------------------------------------------------------------------*/
void TEcranCafard::TueCafard( int i, HDC hdc,HDC hdcMemory )
{
    if( aCafard[i].Existe() )
    {
        aCafard[i].Tue();
        aCafard[i].Restaure( hdc, hdcMemory );
    }
}

/*------------------------------------------------------------------------*/
void TEcranCafard::Genere(/*HDC hdc, HDC hdcMemory */)
{
    int x, y, Orient;
    
    if( nCafards < MaxCafards )//&& random(3) == 1 )
    {
        for( int i = 0; i  < MaxCafards; i ++ )
	{
            if( ! aCafard[i].Existe() )
	    {
                x = random( xEcran );
                y = random( yEcran );
                Orient = random( NB_ORIENT );
                aCafard[i].InitSprite( x, y, Orient );
                nCafards ++;
                break;
	    }
	}
    }
    
}

/*------------------------------------------------------------------------*/
void TEcranCafard::Tue( HDC hdc,HDC hdcMemory )
{
    int nTue;
    
    nTue = random( nCafards );
    if( ( aCafard[nTue].Existe() ) &&
        ( aCafard[nTue].GetX() > xEcran || aCafard[nTue].GetX() < 0 ||
	aCafard[nTue].GetY() > yEcran || aCafard[nTue].GetY() < 0    ) )
    {
        aCafard[nTue].Tue();
        aCafard[nTue].Restaure( hdc, hdcMemory );
        nCafards --;
    }
}
