#include <windows.h>
#include "math.h"
#include "rotctrl.h"
#include "image.h"


extern "C" __declspec(dllexport) void RotEntry() {} 



//  Variables globales
CRotCtrl * pRotCtrl[MAX_WND];


// Inits static
HINSTANCE CRotCtrl::hinstDLL = NULL;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
BOOL WINAPI DllMain(	HINSTANCE hinst,
									DWORD fdwReason,
									LPVOID /*lpvReserved*/ )
{
int i;
    switch( fdwReason )
	    {
	    case DLL_PROCESS_ATTACH:
            for( i = 0; i < MAX_WND; i ++ )
                pRotCtrl[i] = NULL;
            CRotCtrl::hinstDLL = hinst;
            CRotCtrl::RegisterWndClass( CRotCtrl::hinstDLL );
		    break;
	    case DLL_THREAD_ATTACH:
		    break;
	    case DLL_THREAD_DETACH:
		    break;
	    case DLL_PROCESS_DETACH:
            for( i = 0; i < MAX_WND; i ++ )
                if( pRotCtrl[i] )  delete pRotCtrl[i];
		    break;
	    }
    return TRUE;
}


//------------------------------------------------------------------------------
long FAR PASCAL CRotCtrl::RotWndProc( HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam )
{
int nWnd;
    
    switch( message )
	    {
	    case WM_CREATE :
            for( nWnd = 0; nWnd < MAX_WND; nWnd ++ )
                if( ! pRotCtrl[nWnd] )
                    {
                    pRotCtrl[nWnd] = new CRotCtrl ( hwnd );
                    break;
                    }
            pRotCtrl[nWnd]->OnCreate( (LPCREATESTRUCT) lParam );
		    break;
        case WM_PALETTECHANGED :
            ::MessageBox( 0, "WM_PALETTECHANGED", "Message", MB_TASKMODAL );
            break;
        case WM_QUERYNEWPALETTE :
            ::MessageBox( 0, "WM_QUERYNEWPALETTE", "Message", MB_TASKMODAL );
            break;
        case WM_PALETTEISCHANGING :
            ::MessageBox( 0, "WM_PALETTEISCHANGING", "Message", MB_TASKMODAL );
            break;
        case WM_SYSCOLORCHANGE :
            ::MessageBox( 0, "WM_SYSCOLORCHANGE", "Message", MB_TASKMODAL );
            break;
	    case WM_PAINT :
            nWnd = CRotCtrl::GetNumWindow( hwnd);
            if( nWnd < MAX_WND )
                pRotCtrl[nWnd]->OnPaint();
		    break;
	    case WM_SIZE :
            nWnd = CRotCtrl::GetNumWindow( hwnd);
            if( nWnd < MAX_WND )
                pRotCtrl[nWnd]->OnSize( LOWORD(lParam), HIWORD(lParam) );
		    break;
	    case WM_SETCURSOR :
            nWnd = CRotCtrl::GetNumWindow( hwnd);
            if( nWnd < MAX_WND )
                pRotCtrl[nWnd]->OnSetCursor();
		    break;
	    case WM_NCDESTROY :
            nWnd = CRotCtrl::GetNumWindow( hwnd);
            if( nWnd < MAX_WND )
                {
                pRotCtrl[nWnd]->PostNcDestroy();
                delete pRotCtrl[nWnd];
                pRotCtrl[nWnd] = NULL;
                }
		    return 0L;

	    }
    return DefWindowProc( hwnd, message, wParam, lParam );

}



//------------------------------------------------------------------------------
CRotCtrl::CRotCtrl( HWND hwnd) : m_hWnd (hwnd)
{
    fClose  = FALSE;
    bPremier   = TRUE;
    fRotate = FALSE;
    nRotate = 0;
}


//------------------------------------------------------------------------------
CRotCtrl::~CRotCtrl()
{
}

//------------------------------------------------------------------------------
int CRotCtrl::GetNumWindow( HWND hwnd )
{
int i;
    for( i = 0; i < MAX_WND; i ++ )
        if( pRotCtrl[i] )
            if( pRotCtrl[i]->IsWindow( hwnd ) )
                break;
    return i;
}

//------------------------------------------------------------------------------
BOOL CRotCtrl::RegisterWndClass(HINSTANCE hInstance) // static member
                                                    //  function
{
	WNDCLASS wc;
	wc.lpszClassName = "ROTCTRL";
	wc.hInstance = hInstance;
	wc.lpfnWndProc = CRotCtrl::RotWndProc;
	wc.hCursor = ::LoadCursor(NULL, IDC_ARROW);
	wc.hIcon = 0;
	wc.lpszMenuName = NULL;
	wc.hbrBackground = (HBRUSH)::GetStockObject(DEFAULT_GUI_FONT);
	wc.style = CS_GLOBALCLASS;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	return (::RegisterClass(&wc) != 0);
}



//------------------------------------------------------------------------------
void CRotCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct )
{
    strcpy( aResource, 	lpCreateStruct->lpszName );
}

//------------------------------------------------------------------------------
void CRotCtrl::OnPaint() 
{
    if( bPremier )
    	{
        bPremier = FALSE;
        DWORD IDThread;
        HANDLE hthread;
        hthread = CreateThread(NULL, 0,
            (LPTHREAD_START_ROUTINE)RotWinThread, (LPVOID)this, 0, &IDThread);


	    }
    // Redessiner l'image
    fPaint = TRUE;
}


//------------------------------------------------------------------------------
long CRotCtrl::RotWinThread(LPVOID lpvRotCtrl) 
{
HDC hdc;
HDC hdcMemory;
HDC hdcMemory2;
double  nSinus;
long    Echelle;
CRotCtrl * pRotCtrl = (CRotCtrl *)lpvRotCtrl;
TSpriteRot *Image;
int nActive = 0;
BOOL fFirstActive;


    Image = new TSpriteRot(  GetModuleHandle(NULL), pRotCtrl->aResource, 1, 2 );

    hdc = ::GetDC( pRotCtrl->m_hWnd );
	hdcMemory = ::CreateCompatibleDC(hdc);
	hdcMemory2 = ::CreateCompatibleDC(hdc);

	TImage::SaveScreen( hdc, hdcMemory, pRotCtrl->nTailleX, pRotCtrl->nTailleY );

    
    //  On tourne pas au debut
    nSinus = 0;
    srand( 1 );
    pRotCtrl->fRotate = FALSE;

    while( ! pRotCtrl->fClose )
        {
        if( pRotCtrl->fPaint )
            {
            Image->Affiche( hdc, hdcMemory, hdcMemory2 );
            pRotCtrl->fPaint = FALSE;
            }

        Sleep(10);
        if( pRotCtrl->fRotate )
            {
            // Tous les diffrents effets
            if( pRotCtrl->nRotate > ROT_Y  )
                {
	            nSinus += 0.1;
	            Echelle = ( long )( 100 * cos(nSinus) );
		        if( int ( nSinus / (2*PI) ) % 2 )
                    {
			        Image->SetEchelleY( -Echelle );
                    }
		        else
                    {
			        Image->SetEchelleY( Echelle );
                    }
                }
            else if( pRotCtrl->nRotate > ROT_X  )
                {
	            nSinus += 0.1;
	            Echelle = ( long )( 100 * cos(nSinus) );
		        if( int ( nSinus / (2*PI) ) % 2 )
                    {
			        Image->SetEchelleX( -Echelle );
                    }
		        else
                    {
			        Image->SetEchelleX( Echelle );
                    }
                }
            else if( pRotCtrl->nRotate > REBONDIT  )
                {
	            nSinus += 0.1;
	            Echelle = ( long )( 100 * ( 1 - exp(-nSinus) * sin(nSinus) ) );
    	        Image->SetEchelleX( Echelle );
		        Image->SetEchelleY( Echelle );
                }
            if( nSinus >= 2*PI )
                {
                // Retour a la normale
                nSinus = 0;
                pRotCtrl->fRotate = FALSE;
			    Image->SetEchelleX( 100 );
			    Image->SetEchelleY( 100 );
                }
	        if( Echelle < 0 && pRotCtrl->fFirstRotate )
                {
                Image->SetCouche( nActive % 2 );
                nActive ++;
                pRotCtrl->fFirstRotate = FALSE;
                }
//            else
//                Image->SetCouche( 0 );

	        Image->Affiche( hdc, hdcMemory, hdcMemory2 );                
            }
        }
	::DeleteDC(hdcMemory);
	::DeleteDC(hdcMemory2);
	::ReleaseDC(pRotCtrl->m_hWnd, hdc);

    delete Image;
    return 0;
}


//------------------------------------------------------------------------------
void CRotCtrl::OnSize( int cx, int cy) 
{
    nTailleX = cx;
    nTailleY = cy;	
}


//------------------------------------------------------------------------------
void CRotCtrl::OnSetCursor() 
{
	// TODO: Add your message handler code here and/or call default
    if( ! fRotate ) 
        {
        nRotate = rand();
        if( nRotate > REBONDIT )
            {
            fRotate = TRUE;	
            fFirstRotate = TRUE;
            }
        }
}



//------------------------------------------------------------------------------
void CRotCtrl::PostNcDestroy() 
{
    fClose  = TRUE;
    Sleep( 500 );
}


