#ifndef TSPRITE
#define TSPRITE

#define NB_ORIENT 8        
#define NB_COUCHE   2
#define IMAGE "IMAGE"
#define PI 3.14159265359

class TSprite
{
public :
	// Constructeur, destructeur, initialisation
	TSprite( HINSTANCE hInst = NULL, char * aRessource = IMAGE, 
                        int nbOrient= NB_ORIENT, int nbCouche = NB_COUCHE );
	~TSprite();
	
    void Create( HINSTANCE hInst, char * aRessource = IMAGE, 
                        int nbOrient= NB_ORIENT, int nbCouche = NB_COUCHE );
	
    // A surcharger pour optimiser
    virtual void LoadBitmap( HBITMAP * & ahbitmap, char * aRes  );
    virtual void DeleteObject( HBITMAP * & ahbitmap );

    void InitParam();
	void InitSprite( int xPos, int yPos, int nOrientation, int bEx = TRUE);

	// Routines de dplacements
	void Avance( int Orientation );
	void Tourne( int Orientation ) { Orient = Orientation;}
	void TourneTrig() { Orient ++;}
	void TourneHor() { Orient --;}
	void Gauche() { x -= rDeplace; bMove = TRUE;}
	void Droite() { x += rDeplace; bMove = TRUE;}
	void Haut()   { y -= rDeplace; bMove = TRUE;}
	void Bas()    { y += rDeplace; bMove = TRUE;}
	void HautGauche() { Haut(); Gauche(); }
	void BasGauche()  { Bas(); Gauche(); }
	void HautDroite() { Haut(); Droite(); }
	void BasDroite()  { Bas(); Droite(); }

	// Routines d'affichage
	void Save( HDC, HDC );
	void Restaure( HDC, HDC );
	void AfficheBlackSprite( HDC, HDC, DWORD = SRCAND );

	// Sauvegarde cran
	static void SaveScreen( HDC hdc, HDC hdcMemory, int xScreen, int yScreen );
	static void RestScreen( HDC hdc, HDC hdcMemory, int xScreen, int yScreen );
	static void DestroySaveScreen();
	static HBITMAP hBmpSaveScreen;

	// Test existence
	void Cree() { bVisible = TRUE;}
	BOOL Existe() { return bVisible; }
	void Tue() { bVisible = FALSE;}

	// position du sprite
	int GetX() { return x;}
	int GetY() { return y;}
	int GetOrient() { return Orient; }
	int GetCouche() { return Couche; }
	void SetXY( int xPixel, int yPixel ) { x = xPixel; y = yPixel; bMove = TRUE;}
	void SetOrient( int Orientation ) { Orient = Orientation; bMove = TRUE; }
	void SetCouche( int Mvt ) { Couche = Mvt; bMove = TRUE; }
	void Set( int xPixel, int yPixel, int Orientation )
			{ SetXY( xPixel, yPixel ); SetOrient( Orientation ); }
	void Set( int xPixel, int yPixel, int Orientation, int Mvt )
			{ SetXY( xPixel, yPixel ); SetOrient( Orientation ); SetCouche( Mvt ); }
	void SetOld()
		{ xOld = x; yOld = y; OrientOld = Orient; CoucheOld = Couche; }
	BOOL IsMove() { return bMove; }

protected :
    // Handle d'appli
    HINSTANCE hInstance;

	// Parametres gnraux des images
	void Copy( HBITMAP, HDC, HDC, int xDest, int yDest, DWORD dwRop );
	int nOrient;      // Nombre d'orientations maximum
	int nCouche;		// Nombre de mouvements par orientation
	int rDeplace;     // Rayon de dplacement
	POINT *aDeplace;  // Position relatives de dplacements
	int Taille_X;  	// Taille de l'image (X)
	int Taille_Y;  	// Taille de l'image (Y)
	int BitColor;		// Nombre de bits pour la couleur
    int TailleImage;  // Taille de l'image
	HBITMAP * ahBmp;//[NB_ORIENT][NB_COUCHE];
	HBITMAP hBmpSave;

	// Position du sprite
	int x;         // Position horizontale en pixels
	int y;         // Position verticale en pixels
	int Orient;    // Orientation actuelle du sprite
	int Couche;    // Profondeur d'image ( Nbre de mvt )

	// Ancienne position du Sprite
	int xOld;
	int yOld;
	int OrientOld;
	int CoucheOld;
	BOOL bMove;
	BOOL bRestaure;


	// Optimisation / simplification de l'utilisation de la classe
	BOOL bVisible;  // Si faux, pas d'affichage

    // Extension
    BOOL fPremier;
    BITMAPINFO bitmapinfo;
    HPALETTE hPalette;

    // Comptage du nombre des sprites
    static int nSprites;

};
#endif
#pragma hdrstop