
/*------------------------------------------------------------------------*/
//#include "stdafx.h"
#include <windows.h>
#include "SpRot.h"
/*------------------------------------------------------------------------*/



/*------------------------------------------------------------------------*/
TSpriteRot::TSpriteRot( HINSTANCE hInst, char *Res, 
		       int nbOrient, int nbCouche ) 
{  
    if( hInst != NULL )
        Create( hInst, Res, nbOrient, nbCouche );
}

/*------------------------------------------------------------------------*/
void TSpriteRot::Create( HINSTANCE hInst, char *Res, 
			int nbOrient, int nbCouche )
{
    TSprite::Create( hInst, Res, nbOrient, nbCouche );
    // Attention au dpassement de capacit : Faire >> au milieu
    aBmpFond = new unsigned char[ TailleImage ];
    aBmpAffiche = new unsigned char[ TailleImage ];
    
    bPremier = TRUE;
    hBmpFond = NULL;
    hBmpAffiche = NULL;
    
    // Taille reelle
    SetEchelleX( 100 );
    SetEchelleY( 100 );
}

/*------------------------------------------------------------------------*/
TSpriteRot::~TSpriteRot()
{
    if( aBmpFond != NULL ) delete aBmpFond;
    if( aBmpAffiche != NULL ) delete aBmpAffiche;
    if(hBmpFond != NULL) ::DeleteObject( hBmpFond );
    if(hBmpAffiche != NULL) ::DeleteObject( hBmpAffiche );
    }

/*------------------------------------------------------------------------*/
void TSpriteRot::Affiche( HDC hdc, HDC hdcMemory,HDC hdcMemory2 )
{
    HBITMAP hbmpOld, hbmpOld2;
    int xAffEchelle, yAffEchelle;
    int xTailleDest, yTailleDest;
    
    // Cration des bitmaps le 1  coup
    if(bPremier)
    {
	bPremier = FALSE;
	hBmpFond = CreateCompatibleBitmap( hdc, Taille_X, Taille_Y );
	hBmpAffiche = CreateCompatibleBitmap( hdc, Taille_X, Taille_Y );
        switch( BitColor )
	{
	case 4:
	    ptCombineFondImage = &TSpriteRot::CombineFondImage4;
	    break;
	case 8:
	    ptCombineFondImage = &TSpriteRot::CombineFondImage8;
	    break;
	case 16:
	    ptCombineFondImage = &TSpriteRot::CombineFondImage16;
	    break;
	case 24:
	    ptCombineFondImage = &TSpriteRot::CombineFondImage24;
	    break;
	case 32:
	    ptCombineFondImage = &TSpriteRot::CombineFondImage32;
	    break;
	}
	/*long l1, l2, l3, l4;
	int i;
	l1 = GetTickCount();
	for( i = 0; i < 10000; i ++ ) CombineFondImage32Asm();
	l1 = GetTickCount() - l1;
	l2 = GetTickCount();
	for( i = 0; i < 10000; i ++ ) CombineFondImage32();
	l2 = GetTickCount() - l2;
	l3 = GetTickCount();
	for( i = 0; i < 10000; i ++ ) CombineFondImage32Asm();
	l3 = GetTickCount() - l3;
	l4 = GetTickCount();
	for( i = 0; i < 10000; i ++ ) CombineFondImage32Asm();
	l4 = GetTickCount() - l4;
	
	  int a;
	a = 10;*/
    }
    
    
    // on initialise le fond de l'image avec le fond de l'cran
    // seulement si on a chang de place
    if( IsMove() )
    {
	hbmpOld = (HBITMAP)::SelectObject(hdcMemory, hBmpSaveScreen );
	hbmpOld2 = (HBITMAP)::SelectObject(hdcMemory2, hBmpFond );
	::BitBlt(hdcMemory2, 0, 0, Taille_X, Taille_Y, hdcMemory, x, y, SRCCOPY );
	::GetBitmapBits(hBmpFond, TailleImage, aBmpFond );
	::SelectObject(hdcMemory, hbmpOld);
	::SelectObject(hdcMemory2, hbmpOld2);
    }
    
    // Coordonnes d'affichage
    xTailleDest = Taille_X * Echelle_X / 100;
    xAffEchelle = abs((Taille_X - xTailleDest) / 2);
    yTailleDest = Taille_Y * Echelle_Y / 100;
    yAffEchelle = abs((Taille_Y - yTailleDest) / 2);
    
    // Image de destination  blanc
    memset( aBmpAffiche, 255,  TailleImage);
    ::SetBitmapBits(hBmpAffiche, TailleImage, aBmpAffiche );
    
    // On copie l'image dans une bitmap
    hbmpOld = (HBITMAP)::SelectObject(hdcMemory, ahBmp[Orient * nCouche + Couche] );
    hbmpOld2 = (HBITMAP)::SelectObject(hdcMemory2, hBmpAffiche );
    StretchBlt(hdcMemory2, xAffEchelle, yAffEchelle, xTailleDest, yTailleDest, hdcMemory, 0, 0,
				    Taille_X, Taille_Y, SRCCOPY);
    ::GetBitmapBits(hBmpAffiche, TailleImage, aBmpAffiche );
    ::SelectObject(hdcMemory, hbmpOld);
    ::SelectObject(hdcMemory2, hbmpOld2);
    
    // On associe le fond et l'image
    (this->*ptCombineFondImage)();
    ::SetBitmapBits(hBmpAffiche, TailleImage, aBmpAffiche );
    
    // On affiche
    hbmpOld = (HBITMAP)::SelectObject(hdcMemory, hBmpAffiche );
    
    ::BitBlt(hdc, x, y, Taille_X, Taille_Y, hdcMemory, 0, 0, SRCCOPY );
    ::SelectObject(hdcMemory, hbmpOld);
    
    // Initialisations si on bouge (voir TSprite)
    SetOld();
    bMove = FALSE;
}

/*------------------------------------------------------------------------*/
void TSpriteRot::CombineFondImage4()
{
    for( int i = 0; i <  TailleImage; i ++ )
    {
        if( (aBmpAffiche[i] & 0x0F) == 0x0F ) 
            aBmpAffiche[i] = (aBmpAffiche[i] & 0xF0) | (aBmpFond[i] & 0x0F );
        if( (aBmpAffiche[i] & 0xF0) == 0xF0 ) 
            aBmpAffiche[i] = (aBmpAffiche[i] & 0x0F) | (aBmpFond[i] & 0xF0 );
    }
}

/*------------------------------------------------------------------------*/
void TSpriteRot::CombineFondImage8()
{
    for( int i = 0; i <  TailleImage; i ++ )
        if( aBmpAffiche[i] == 255 ) aBmpAffiche[i] = aBmpFond[i];
}


/*------------------------------------------------------------------------*/
void TSpriteRot::CombineFondImage16()
{
    unsigned short s_color = /*(unsigned short)( *((unsigned short *) (aBmpAffiche)) )*/0x7FFF;
    for( int i = 0; i <  TailleImage / 2; i ++ )
        if( ((unsigned short)( *((unsigned short *) (aBmpAffiche + i*2)) ) & s_color) == s_color ) 
            (unsigned short)( *((unsigned short *) (aBmpAffiche + i*2)) ) = 
	    (unsigned short)( *((unsigned short *) (aBmpFond + i*2)) );
}

/*------------------------------------------------------------------------*/
void TSpriteRot::CombineFondImage24()
{
    for( int i = 0; i <  TailleImage; i += 3 )
        if( aBmpAffiche[i]  == 0xFF && aBmpAffiche[i+1]  == 0xFF && aBmpAffiche[i+2]  == 0xFF )
	{
            aBmpAffiche[i] = aBmpFond[i];
            aBmpAffiche[i+1] = aBmpFond[i+1];
            aBmpAffiche[i+2] = aBmpFond[i+2];
	}
}

/*------------------------------------------------------------------------*/
void TSpriteRot::CombineFondImage32()
{
    
    for( int i = 0; i <  TailleImage / 4; i ++ )
        if(  !(((unsigned int)( *((unsigned int *) (aBmpAffiche + i*4)) ) & 0x00FFFFFF) ^ 0x00FFFFFF) ) 
            (unsigned int)( *((unsigned int *) (aBmpAffiche + i*4)) ) = 
	    (unsigned int)( *((unsigned int *) (aBmpFond + i*4)) );
	
}
/*------------------------------------------------------------------------*/
void TSpriteRot::CombineFondImage32Asm()
{
    int nImage = TailleImage;
    char * pAffiche;
    char * pFond;
    
    pAffiche = (char *)aBmpAffiche;
    pFond = (char *)aBmpFond;
    
    __asm
    {
	mov ebx, pAffiche
	    mov edx, pFond
	    mov ecx, nImage
boucle:
	sub ecx, 4
	    push ebx
	    push edx
	    add ebx, ecx
	    mov eax, [ebx]
	    and eax, 00ffffffh
	    xor eax, 00ffffffh
	    jnz pasBlanc
	    add edx, ecx
	    mov esi, [edx]
	    mov [ebx], esi
	    
pasBlanc:
	pop edx
	    pop ebx
	    or ecx, ecx
	    jnz boucle
    }
}

